<template>
  <div class="game">
    <PageTitle>{{ game.name }}</PageTitle>
    <div class="gamedata" v-if="game">
      <div class="col">
        <p>Game status:</p>
        <p>Kill method:</p>
        <p>Players alive:</p>
        <p>End date:</p>

        <p v-if="isPlayer">Your status:</p>
        <p v-if="isPlayer">Target:</p>
        <p v-if="isPlayer">Rank:</p>
        <p v-if="isPlayer">Kill count:</p>
      </div>
      <div class="col">
        <p>{{ game.state }}</p>
        <p>{{ game.method.name || "Unavailable" }}</p>
        <p>{{ game.playersAlive }}</p>
        <p>{{ game.endDate || "None" }}</p>

        <p v-if="isPlayer">{{ game.player.isDead ? "Dead" : "Alive" }}</p>
        <p v-if="isPlayer">
          {{ game.player?.target?.username || "Unavailable" }}
        </p>
        <p v-if="isPlayer">{{ game.player.rank || "Unavailable" }}</p>
        <p v-if="isPlayer">{{ game.player.killCount }}</p>
      </div>
    </div>
    <div class="buttons">
      <RedirectButton @click="messages">Messages</RedirectButton>
      <RedirectButton v-if="!isPlayer" @click="archivedMessages">
        Archived Messages
      </RedirectButton>
      <ActionButton
        v-if="game.state === 'Active' && !game.player.isDead"
        @click="gotKilled"
      >
        Got killed
      </ActionButton>
    </div>
  </div>
</template>

<script>
import RedirectButton from "../atoms/RedirectButton.vue";
import ActionButton from "../atoms/ActionButton.vue";
import PageTitle from "../atoms/PageTitle.vue";
import axios from "axios";
import store from "../../store/auth";

export default {
  components: { RedirectButton, ActionButton, PageTitle },
  props: {
    game: {
      type: Object,
    },
  },
  computed: {
    isPlayer() {
      return store.getters["auth/getUser"].role === "player";
    },
  },
  methods: {
    async gotKilled() {
      await axios.post(
        `api/games/${this.game.id}/players/${this.game.player.player_id}/kill`
      );
      this.$router.go();
    },
    messages() {
      if (store.getters["auth/getUser"].role === "player") {
        this.$router.push({ name: "messages", params: { id: this.game.id } });
      } else {
        this.$router.push({
          name: "latestPlayerMessages",
          params: { id: this.game.id },
        });
      }
    },
    archivedMessages() {
      this.$router.push({
        name: "archivedMessages",
        params: { id: this.game.id },
      });
    },
  },
};
</script>

<style lang="scss">
.game {
  margin: auto;
  margin-top: 0.5rem;
  background-color: white;
  padding: 0rem 1rem;
  border: 0.1rem #09639b solid;
  border-radius: 0.2rem;
  align-self: center;
  justify-self: center;
  width: 90vw;
  max-width: 24rem;

  .gamedata {
    display: flex;
    flex-direction: row;
    justify-content: space-evenly;
    align-items: start;
    color: black;
    .col {
      display: flex;
      flex-direction: column;
      justify-content: space-evenly;
      align-items: flex-start;
    }
  }
  h2 {
    color: #09639b;
    text-decoration: none;
    font-weight: bold;
    font-size: 1rem;
  }
  .buttons {
    display: flex;
    flex-direction: row;
    justify-content: space-evenly;
  }
}
</style>
